#define _WINSOCKAPI_      // Prevent winsock.h from being included
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "FileWin.h"
#include "FileMan.h"
#include "Global.h"
#include "pgpmail.h"
#include "mixmaster.h"
#include "cyberpunk.h"
#include "Remailerdlgs.h"
#include "helpdlgs.h"
#include "view.h"
//---------------------------------------------------------------------------
#pragma link "TextWins"
#pragma link "explbtn"
#pragma resource "*.dfm"
TTextFileWin *TextFileWin;
//---------------------------------------------------------------------------
void __fastcall EditTextFile(AnsiString &Filename, TForm *Owner)
{
   AnsiString s;
   Application->MainForm->Cursor = crHourGlass;
   if (Filename==mtyp2txt && HasMix())
   {  // special handling of type2.list
      TStringList *lines = new TStringList();
      lines->LoadFromFile(Filename);
      MixSpaceType2(lines);
      if (lines->Count)
      {
         lines->Sorted = true;
         bool ok=false;
         for (int i=0; i<lines->Count; i++)
            if (lines->Strings[i].SubString(1,1)!="#")
               ok = true;
         lines->Sorted = false;
         if (ok) while (lines->Strings[0].SubString(1,1)=="#")
         {
            s = lines->Strings[0];
            lines->Delete(0);
            lines->Add(s);
         }
         EditFileText(lines,Filename);
         delete lines;
         Application->MainForm->Cursor = crDefault;
         return;
      }
   }
   TextFileWin = new TTextFileWin(Filename,Owner);
   Application->MainForm->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall ViewHistoryFile(AnsiString &FileName, TForm *Owner)
{
   Application->MainForm->Cursor = crHourGlass;
   TextFileWin = new TTextFileWin(FileName,Owner);
   Application->MainForm->Cursor = crDefault;
}
//---------------------------------------------------------------------------
bool __fastcall TTextFileWin::Save()
{
   AnsiString fn=filename;
   int bakcopies=STATSBAKCOPIES;
   AnsiString cap = Caption; Caption = "Saving..."; AppProcessMessages(); Sleep(200);
   Application->MainForm->Cursor = crHourGlass;
   TStringList *lines = new TStringList();
   lines->Text = Editor->Lines->Text;
   TrimNulls(lines);
   // special handling of pubring.mix
   if (HasMix() && fn==mringtxt)
   {
      // generate a new type2.list
      TStringList *type2 = new TStringList();
      if (FileExists(mtyp2txt)) type2->LoadFromFile(mtyp2txt);
      {
         MixGenType2(type2,lines); // type2
         MixSpaceType2(type2);
         SaveToFileBak(type2,mtyp2txt,bakcopies);
      }
      delete type2;
   }
   // special handling of type2.list
   if (fn==mtyp2txt) MixUnSpaceType2(lines);
   // save the document===============================
   if (fn==cringtxt || fn==clisttxt || fn==mringtxt || fn==mlisttxt)
      SaveToFileBak(lines,fn,bakcopies);
   else
      lines->SaveToFile(fn);
   //==========================

   Application->MainForm->Cursor = crDefault;
   Caption = cap;
   delete lines;
   return true;
}
//---------------------------------------------------------------------------
void __fastcall EditFileText(TStrings *Text, AnsiString &FileName, TForm *Owner)
{
   TextFileWin = new TTextFileWin(Text,FileName,Owner);
   if (ExtractFileName(FileName)==MTyp2Txt || ExtractFileName(FileName)==CTyp1Txt)
      TextFileWin->CheckBox1->Visible = true;
}
//---------------------------------------------------------------------------
__fastcall TTextFileWin::TTextFileWin(TComponent* Owner)
  : TTextWin(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TTextFileWin::TTextFileWin(AnsiString &Filename, TComponent* Owner)
  : TTextWin(Owner)
{
   Editor->WordWrap = false;
   if (ExtractFileName(Filename).LowerCase().Pos("history.")==1) Editor->WordWrap = true;
   filename = Filename;
   if (FileExists(filename))
   {
      Caption = "...\\"+ExtractFileName(filename);
      Editor->Lines->LoadFromFile(filename);
      Editor->Modified = false;
      ShowCurXY(true);
   }

   if (Filename==MixDir()+MixCfg)
   {
      TStrings *lines = Editor->Lines;
      while (lines->Count && lines->Strings[lines->Count-1].IsEmpty())
         lines->Delete(lines->Count-1);
      lines->Add("");
      if (!lines->Text.LowerCase().Pos("distance")) lines->Add("DISTANCE 2");
      if (!lines->Text.LowerCase().Pos("minrel")) lines->Add("MINREL 98");
      if (!lines->Text.LowerCase().Pos("relfinal")) lines->Add("RELFINAL 99");
      if (!lines->Text.LowerCase().Pos("maxlat")) lines->Add("MAXLAT 36h");
      lines->SaveToFile(Filename);
      Editor->Modified = false;
      HelpBtn->Visible = true;
   }
   else
   if (Filename==MixDir()+MRingTxt)
   {
      HelpBtn->Visible = true;
   }
   Editor->SelStart = 0;

   if (Filename.LowerCase()==MixDir().LowerCase()+"errlog")
   {
      Editor->SelStart = Editor->Lines->Text.Length();
      ClearBtn->Visible = true;
      Bevel7->Visible = true;
   }
   FormResize(NULL);
}
//---------------------------------------------------------------------------
__fastcall TTextFileWin::TTextFileWin(TStrings *Txt, AnsiString &Filename, TComponent* Owner)
  : TTextWin(Owner)
{
   filename = Filename;
   Editor->WordWrap = false;
   SetText(ExtractFileName(Filename),Txt);
   if (Filename==MixDir()+MixCfg)
   {
      TStrings *lines = Editor->Lines;
      while (lines->Count && lines->Strings[lines->Count-1].IsEmpty())
         lines->Delete(lines->Count-1);
      lines->Add("");
      if (!lines->Text.LowerCase().Pos("distance")) lines->Add("DISTANCE 2");
      if (!lines->Text.LowerCase().Pos("minrel")) lines->Add("MINREL 98");
      if (!lines->Text.LowerCase().Pos("relfinal")) lines->Add("RELFINAL 99");
      if (!lines->Text.LowerCase().Pos("maxlat")) lines->Add("MAXLAT 36h");
      lines->SaveToFile(Filename);
      Editor->Modified = false;
      HelpBtn->Visible = true;
   }
   ActiveControl = Editor;
   Editor->SelStart = 0;
   FormResize(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TTextFileWin::SortTypeList(bool DisabledAtBottom)
{
   TStringList *lines = new TStringList(); lines->Sorted = true;
   lines->AddStrings(Editor->Lines);
   if (lines->Count)
   {
      bool ok=false;
      if (DisabledAtBottom)
      {
         lines->Sorted = false;
         for (int i=0; i<lines->Count; i++)
            if (lines->Strings[i].SubString(1,1)!="#")
               ok = true; // make sure not all lines begin "#'
         if (ok) while (lines->Strings[0].SubString(1,1)=="#")
         {
            AnsiString s = lines->Strings[0];
            lines->Delete(0);
            lines->Add(s);
         }
      }
   }
   Editor->Lines->Text = lines->Text;
}
//---------------------------------------------------------------------------
bool __fastcall TTextFileWin::SaveAs()
{// not needed but placed for safety
   return false;
}
//---------------------------------------------------------------------------
void __fastcall TTextFileWin::SetText(AnsiString &Name, TStrings *Text)
{
//   IndexStr = Name;
//   DataKey = UserNotes+PS+Name;
   Caption = Name;
   Editor->OnSelectionChange = NULL;
   Editor->Lines->Text = Text->Text;
   Editor->Modified = false;
   Editor->SelStart = 0;
   Editor->OnSelectionChange = EditorSelectionChange;
   ShowCurXY(true);
}
//---------------------------------------------------------------------------
void __fastcall TTextFileWin::CheckBox1Click(TObject *Sender)
{
   bool mod = Editor->Modified;
   if (CheckBox1->Checked) SortTypeList(true);
   else SortTypeList(false);
   Editor->Modified = mod;
}
//---------------------------------------------------------------------------
void __fastcall TTextFileWin::FormResize(TObject *Sender)
{
   if (HelpBtn->Visible) HelpBtn->Left = Width - 40;
}
//---------------------------------------------------------------------------
void __fastcall TTextFileWin::HelpBtnClick(TObject *Sender)
{
   if (filename==MixDir()+MRingTxt)
   {
      OpenHelp("MixmasterDocs","Mixmaster Pubring.mix","",AppMainForm);
   }
   if (filename==MixDir()+MixCfg)
   {
      OpenHelp("Config","Mixmaster Configuration","",AppMainForm);
   }
}
//---------------------------------------------------------------------------
