//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "PgpRecipDlgs.h"
#include "PGPbuffers.h"
#include "PgpFiles.h"
#include "QSver.h"
#include "Global.h"
#include "mixmaster.h"
#include "pgp.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TPgpRecipDlg *PgpRecipDlg;
//---------------------------------------------------------------------------
bool __fastcall PGPgetEncryptList(TStrings *Recips, bool CanConvent)
{
   bool ok=false;
   TPgpRecipDlg *pf = new TPgpRecipDlg(ActMainForm,Recips,CanConvent);
   if (pf->opendlg) pf->ShowModal();
   if (pf->ModalResult==mrOk || !pf->opendlg)
      ok = true;
   delete pf;
   return ok;
}
//---------------------------------------------------------------------------
__fastcall TPgpRecipDlg::TPgpRecipDlg(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TPgpRecipDlg::TPgpRecipDlg(TComponent* Owner, TStrings *Recips,
   bool CanConvent) : TForm(Owner)
{
   CenterDialog(this,(TForm*)Owner);
   opendlg = true;
   recips = Recips;
   AnsiString keystr;
   ListBox1->Clear();
   RemKeys->Enabled = false;
   keys = new TStringList();
   To = new TStringList();
   pubdb = new TPGPbuffer(PgpPublicRing());
   cpkdb = NULL;
   if (FileExists(PgpRemailRing()))
   {
      cpkdb = new TPGPbuffer(PgpRemailRing(),NO_DISABLED);
      RemKeys->Enabled = true;
   }
   // transfer recips to list, skipping dialog if all recips have pubkeys
   for (int i=0; i<recips->Count; i++)
   {
      keystr = GetKeyStr(recips->Strings[i]);
      if (GetParam(1,keystr,"\255").Pos("0x")!=1) opendlg=true;
      ListBox2->Items->Add(keystr);
   }

   Conventional->Enabled = CanConvent;
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
AnsiString __fastcall  TPgpRecipDlg::KeyStr(TPGPbuffer *key, int id)
{
   AnsiString uid,keystr,idtext8=key->idtext8;
   TStringList *uids = new TStringList();
   key->getuserids(uids);
   if (id>=0 && id<uids->Count) uid = uids->Strings[id];
   delete uids;

   keystr = uid+"\255"+"0x"+idtext8+"\255"+key->algostr+"\255"+
      key->bitsstr+"\255"+key->filename;
   return keystr;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPgpRecipDlg::GetKeyStr(AnsiString &id)
{
   int uid;
   AnsiString keystr;
   TStringList *uids = new TStringList();
   TPGPbuffer *key,*db=pubdb; db->rewind(); key=new TPGPbuffer();
start:
   while (key->copykeyfrom(db,REWIND))
   {
      // if there is a IdText8 in the string
      if (id.Pos("0x")==1 && id.SubString(3,8)==key->idtext8)
      {
         keystr = GetToken(0,KeyStr(key,0),"\255");
         break;
      }
      uid = -1; // is the recip id within any userids of this key
      key->getuserids(uids);
      for (int i=0; i<uids->Count; i++)
      {
         if (uids->Strings[i].Pos(id)>0)
         {
            uid = i;
            break;
         }
      }
      if (uid>=0)
      {
         keystr = KeyStr(key,uid);
         break;
      }
   }
   // if not found and remkeys not checked loop back up
   if (keystr.IsEmpty() && db==pubdb && cpkdb)
   {
      db = cpkdb; db->rewind();
      goto start;
   }

   if (keystr.IsEmpty())
      keystr = id;

   delete uids;
   delete key;
   return keystr;
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipDlg::LoadPublics(TPGPbuffer *db)
{
   db->rewind();
   ListBox1->Clear();
   AnsiString descrip;
   Application->ProcessMessages();Sleep(100);
   ListBox1->Sorted = SortBox->Checked;
   TStringList *ids = new TStringList();
   TPGPbuffer *key = new TPGPbuffer();
   TStringList *uids = new TStringList();
   key->filename = db->filename;
   while (key->copykeyfrom(db,REWIND))
   {
      if (key->enabled && !key->revoked)
      {
         key->getuserids(uids);
         for (int i=0; i<uids->Count; i++)
         {
            descrip = KeyStr(key,i);
            if (ids->IndexOf(descrip)<0) ids->Add(descrip);
         }
      }
      key->clear();
   }
   ListBox1->Items->Text = ids->Text;
   delete uids;
   delete ids;
}
/*
void __fastcall TPgpRecipDlg::LoadPublics(TPGPbuffer *db)
{
   db->rewind();
   ListBox1->Clear();
   AnsiString descrip;
   Application->ProcessMessages();Sleep(100);
   ListBox1->Sorted = SortBox->Checked;
   TStringList *ids = new TStringList();
   TPGPbuffer *key = new TPGPbuffer();
   TStringList *uids = new TStringList();
   key->filename = db->filename;
   while (key->copykeyfrom(db,REWIND))
   {
      if (key->enabled && !key->revoked)
      {
         key->getuserids(uids);
         for (int i=0; i<uids->Count; i++)
         {
            descrip = KeyStr(key,i);
            if (ids->IndexOf(descrip)<0) ids->Add(descrip);
         }
      }
      key->clear();
   }
   ListBox1->Items->Text = ids->Text;
   delete uids;
   delete ids;
}
*/
//---------------------------------------------------------------------------
__fastcall TPgpRecipDlg::~TPgpRecipDlg()
{
   delete cpkdb;
   delete pubdb;
   delete keys;
   delete To;
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipDlg::WhichKeysClick(TObject *Sender)
{
   LoadPublics(MyKeys->Checked ? pubdb : cpkdb);
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipDlg::ListBoxDrawItem(TWinControl *Control, int Index,
  TRect &Rect, TOwnerDrawState State)
{
   TRect r = Rect;
   TListBox *ListBox = dynamic_cast<TListBox*>(Control);
   TCanvas *canvas = ListBox->Canvas;
   canvas->FillRect(r);
   int rr = r.Right;
   AnsiString keystr = ListBox->Items->Strings[Index];
   // username/address
   r.Left += 6; r.Right = r.Left + 302;
   // recip with no key
   if (ListBox==ListBox2 && GetParam(1,keystr,"\255").SubString(1,2)!="0x")
   {
      TFontStyles style;
      canvas->Font->Style = style << fsStrikeOut;
      canvas->TextRect(r,r.Left,r.Top,keystr+" ");
      return;
   }
   // recip /w key OR a key
   AnsiString name=GetParam(0,keystr,"\255");
   canvas->TextRect(r,r.Left,r.Top,name);
   // if text is too long for rect
   if (canvas->TextWidth(name)>r.Right-r.Left) canvas->TextOut(r.Right-7,r.Top,"...");
   // key id
   int ml = canvas->TextWidth("D")-1;
   AnsiString keyid = GetParam(1,keystr,"\255");
   r.Left = r.Right+20; r.Right = r.Left+ml;
   for (int i=1; i<=keyid.Length(); i++)
   {
      canvas->TextRect(r,r.Left,r.Top,keyid.SubString(i,1));
      r.Left += ml; r.Right = r.Left + ml;
   }
   // key algo
   r.Left = r.Right + 12; r.Right = r.Left+45;//rr - 5;
   canvas->TextRect(r,r.Left,r.Top,GetParam(2,keystr,"\255"));
   // key bits
   r.Left = r.Right + 2; r.Right = rr - 5;
   canvas->TextRect(r,r.Left,r.Top,GetParam(3,keystr,"\255"));
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipDlg::ListBox1DblClick(TObject *Sender)
{
   if (ListBox1->ItemIndex>=0)
   {
      AnsiString remstr = ListBox1->Items->Strings[ListBox1->ItemIndex];
      if (ListBox2->Items->IndexOf(remstr)>=0) MyBeep(0);
      else ListBox2->Items->Add(remstr);
      //ListBox1->Items->Delete(ListBox1->ItemIndex);
   }
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipDlg::ListBox2DblClick(TObject *Sender)
{
//   if (ListBox2->ItemIndex>=0 && MsgBoxHwnd(Handle,"Remove this recipient?",
//      "Confirm",MB_OKCANCEL)==IDOK)
   if (ListBox2->ItemIndex>=0)
   {
       //ListBox1->Items->Add(ListBox2->Items->Strings[ListBox2->ItemIndex]);
       ListBox2->Items->Delete(ListBox2->ItemIndex);
   }
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipDlg::FormShow(TObject *Sender)
{
   TStrings *items = ListBox2->Items;
   bool ok=true;
   for (int i=0; i<items->Count; i++)
      if (GetParam(1,items->Strings[i],"\255").SubString(1,2)!="0x")
      {
         ok = false;
         break;
      }
   if (ok) Label1->Caption =
      s("Your recipient list is valid. To encrypt your message to other recipients, drag the addresses\n")+
      s("from the upper list to the lower.");
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipDlg::ConventionalClick(TObject *Sender)
{
   if (Conventional->Checked)
   {
      To->Text = ListBox2->Items->Text;
      ListBox1->Clear(); ListBox1->Color = clBtnFace; ListBox1->Enabled = false;
      ListBox2->Clear(); ListBox2->Color = clBtnFace; ListBox2->Enabled = false;
      if (cpkdb) RemKeys->Enabled = false;
      SortBox->Enabled = false;
      MyKeys->Enabled = false;
   }
   else
   {
      ListBox1->Color = clWindow; ListBox1->Enabled = true;
      ListBox2->Color = clWindow; ListBox2->Enabled = true;
      LoadPublics(MyKeys->Checked ? pubdb : cpkdb);
      if (cpkdb) RemKeys->Enabled = true;
      ListBox2->Items->Text = To->Text;
      SortBox->Enabled = true;
      MyKeys->Enabled = true;
   }
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrOk && !ListBox2->Items->Count && !Conventional->Checked)
   {
      MsgBoxHwnd(Handle,
         AnsiString("You must either select at least one valid recipient\n")+
         AnsiString("or choose the Conventional Encryption option"),
        "No Recipients Selected",
         MB_OK);
      CanClose = false;
   }
   recips->Clear();
   if (Conventional->Checked) recips->Add(UseConventional);
   else
   {
      for (int i=0; i<ListBox2->Items->Count; i++)
      {
         AnsiString id8,recip=ListBox2->Items->Strings[i];
         id8 = GetToken(1,recip,"\255"); if (id8.Pos("0x")!=1) continue;
         recips->Add(id8+" "+GetToken(0,recip,"\255"));
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipDlg::ListBox2DragOver(TObject *Sender,
  TObject *Source, int X, int Y, TDragState State, bool &Accept)
{
   TListBox *src = dynamic_cast<TListBox*>(Source);
   if (src==ListBox1)
//   if (src && ListBox2->Items->IndexOf(src->Items->Strings[src->ItemIndex])<0)
      Accept=true;
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipDlg::ListBox2DragDrop(TObject *Sender,
  TObject *Source, int X, int Y)
{
   TListBox *src = dynamic_cast<TListBox*>(Source);
   if (src==ListBox1)
   {
      AnsiString addr = src->Items->Strings[src->ItemIndex];
      if (ListBox2->Items->IndexOf(addr)<0)
         ListBox2->Items->Add(addr);
      else MyBeep(0);
    //src->Items->Delete(src->ItemIndex);
   }
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipDlg::ListBox1DragDrop(TObject *Sender,
  TObject *Source, int X, int Y)
{
    TListBox *src = dynamic_cast<TListBox*>(Source);
    if (src==ListBox2)
    {
       AnsiString addr = src->Items->Strings[src->ItemIndex];
       if (ListBox1->Items->IndexOf(addr)<0)
          ListBox1->Items->Add(addr);
       else MyBeep(0);
       ListBox1->Items->Add(src->Items->Strings[src->ItemIndex]);
       //src->Items->Delete(src->ItemIndex);
    }
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipDlg::ListBox1DragOver(TObject *Sender,
  TObject *Source, int X, int Y, TDragState State, bool &Accept)
{
   TListBox *src = dynamic_cast<TListBox*>(Source);
   if (src==ListBox2) Accept = true;
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipDlg::SortBoxClick(TObject *Sender)
{
   LoadPublics(MyKeys->Checked ? pubdb : cpkdb);
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipDlg::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
   SetRedraw(ListBox1,0);
   LoadPublics(MyKeys->Checked ? pubdb : cpkdb);
   for (int i=0; i<3; i++) AppProcessMessages();
   SetRedraw(ListBox1,1);
//   sm(ListBox2->Items->Text);
}
//---------------------------------------------------------------------------
