#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <filectrl.hpp>
#pragma hdrstop

#include "UPDateDlg.h"
#include "UPDunzipDlg.h"
#include "UPDedDlg.h"
#include "UPDftpDlg.h"
#include "UPDhistDlgs.h"
#include "global.h"
#include "dir.h"
#include "fileman.h"
#include "QSver.h"
#include "pop3mail.h"
#include "pgpmail.h"
#include "pgpsdk.h"
#include "nymmail.h"
#include "wipedlgs.h"
//---------------------------------------------------------------------------
#pragma link "Ftpcli"
#pragma resource "*.dfm"
TUPDateQsDlg *UPDateQsDlg;
#define TEMP_FILE_NAME "FTPDIR.TXT"
//---------------------------------------------------------------------------
AnsiString __fastcall RunUpdateExpress(TForm *MainForm, bool &Cancel)
{
   Cancel = false;
   AnsiString RunProgramOnExit,filename,ext;
   UPDateQsDlg = new TUPDateQsDlg(MainForm);
   UPDateQsDlg->MainForm = MainForm;
   UPDateQsDlg->ShowModal();
   int mrResult=UPDateQsDlg->ModalResult;
   if (mrResult==mrOk)
   {
      filename = UPDateQsDlg->LocalName.LowerCase();
      ext = ExtractFileExt(filename);
      if (ext==".zip")
      {
         if (UPDateQsDlg->IsMixmaster) RunProgramOnExit = AppExeName+" -mix \""+filename+"\"";
         else if (UPDateQsDlg->runQS) RunProgramOnExit = AppExeName;
      }
      if (ext==".exe") RunProgramOnExit = UPDateQsDlg->LocalName;
   }
   else
      Cancel = true;
   delete UPDateQsDlg;
   return RunProgramOnExit;
}
//---------------------------------------------------------------------------
__fastcall TUPDateQsDlg::TUPDateQsDlg(TComponent* Owner)
  : TForm(Owner)
{
   Notebook1->PageIndex = 0;
   ListBox1->Align = alClient;
   GetAppData(FtpSite->Items,UpdateSites);
   if (!FtpSite->Items->Count)
   {
      FtpSite->Items->Add("ftp.skuz.net/pub/quicksilver");
      FtpSite->Items->Add("local file");
   }
   FtpSite->ItemIndex = 0;
   HostDir->Clear();
   // local file stuff
   //AnsiString dir = AppDir+"updates";
   //if (!DirectoryExists(dir)) CreateDirectory(dir.c_str(),NULL);
   //if (!DirectoryExists(dir)) dir = AppDir;
   //DirectoryListBox1->Directory = dir;
   FTPfields = new TStringList();
   switch (GetAppIni(FtpProxy,"").ToIntDef(0))
   {
      case 1: ClassProxyClick(0); break;
      case 2: TransProxyClick(0); break;
      case 3: UserProxyClick(0); break;
      default:
         NoProxyClick(0); break;
   }
   if (ProxyHost().IsEmpty())
   {
      ClassProxy->Enabled = false;
      TransProxy->Enabled = false;
   }
   CenterDialog(this,(TForm*)Owner);
   IsMixmaster = false;
   DbEncrypted = false;
   runQS = false;

   Label12->Caption = "Current:  QS"+ReleaseVer.Trim();
   if (HasPop3())
      Label12->Caption = Label12->Caption+"   QSpop"+GetPop3Version();
   if (HasPgp())
      Label12->Caption = Label12->Caption+"   QSpgp"+GetPgpLibVersion();
   /*if (HasSdk())
   {
      AnsiString libname = GetParam(0,GetQdkLibName()," ").SubString(3,16).LowerCase();
      Label12->Caption = Label12->Caption+"  QS"+libname+GetQdkLibVersion();
   }*/
   if (HasNyms())
      Label12->Caption = Label12->Caption+"   QSnym"+GetNymLibVersion();
}
//---------------------------------------------------------------------------
__fastcall TUPDateQsDlg::~TUPDateQsDlg()
{
   int checkedProxy=ClassProxy->Checked?1:TransProxy->Checked?2:UserProxy->Checked?3:0;
   PutAppIni(FtpProxy,AnsiString(checkedProxy));
   delete FTPfields;
}
//---------------------------------------------------------------------------
void __fastcall TUPDateQsDlg::StoreUserProxy(TStrings *fields)
{
   PutAppData(FtpProxy,fields);
}
//---------------------------------------------------------------------------
void __fastcall TUPDateQsDlg::LoadUserProxy(TStrings *fields)
{
   GetAppData(fields,FtpProxy);
   if (fields->Text.IsEmpty())
   {
      AnsiString host = GetParam(0,FtpSite->Text,"/");
      fields->Values["HostName"] = host;
      fields->Values["HostDir"] = FtpSite->Text.SubString(host.Length()+1,256);
      fields->Values["HostPort"] = "21";
      fields->Values["UserName"] = "anonymous";
      fields->Values["Password"] = "nobody@nowhere.net";
      fields->Values["Passive"] = "0";
   }
   HostName->Text = fields->Values["HostName"];
   HostDir->Text = fields->Values["HostDir"];
   HostPort->Text = fields->Values["HostPort"];
   UserName->Text = fields->Values["UserName"];
   Password->Text = fields->Values["Password"];
   PassiveBox->Checked = fields->Values["Passive"]=="1";
   PassiveBox->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TUPDateQsDlg::SetFieldsProxy()
{
   FTPfields->Clear();
   FTPfields->Add("HostName="+HostName->Text);
   FTPfields->Add("HostDir="+HostDir->Text);
   FTPfields->Add("HostPort="+HostPort->Text);
   FTPfields->Add("UserName="+UserName->Text);
   FTPfields->Add("Password="+Password->Text);
   FTPfields->Add("Passive="+AnsiString(PassiveBox->Checked?1:0));
   if (UserProxy->Checked) StoreUserProxy(FTPfields);
}
//---------------------------------------------------------------------------
void __fastcall TUPDateQsDlg::SetFieldsNoProxy()
{
   FTPfields->Clear();
   AnsiString host = GetParam(0,FtpSite->Text,"/");
   FTPfields->Add("HostName="+host);
   FTPfields->Add("HostDir="+FtpSite->Text.SubString(host.Length()+1,256));
   FTPfields->Add("HostPort=21");
   FTPfields->Add("UserName=anonymous");
   FTPfields->Add("Password=nobody@nowhere.net");
   FTPfields->Add("Passive=0");
}
//---------------------------------------------------------------------------
bool __fastcall TUPDateQsDlg::IsMixmasterUpdate(AnsiString &Filename)
{
   if (!FileExists(Filename)) return false;
   AnsiString name=ExtractFileName(Filename).LowerCase(),ext=ExtractFileExt(name);
   if (name.SubString(1,6)=="mix29b" && ext==".zip") return true;
   if (name.SubString(1,4)=="mix3" && ext==".zip") return true;
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall TUPDateQsDlg::Exec95Zip(AnsiString &ZipFileName)
{
   return UnzipQSPlugins(MainForm,ZipFileName,runQS);
}
//---------------------------------------------------------------------------
bool __fastcall TUPDateQsDlg::Exec95Txt(AnsiString &TxtFileName)
{
   UPDHistDlg = new TUPDHistDlg(this);
   if (FileExists(TxtFileName))
      UPDHistDlg->RichEdit1->Lines->LoadFromFile(TxtFileName);
   UPDHistDlg->Caption = ExtractFileName(TxtFileName);
   UPDHistDlg->ShowModal();
   delete UPDHistDlg;
   return true;
   //return Exec95("notepad.exe "+TxtFileName,SW_SHOWNORMAL)>0;
}
//---------------------------------------------------------------------------
void __fastcall TUPDateQsDlg::NextBtnClick(TObject *Sender)
{
   static AnsiString name;
   AnsiString ext,updateinfo,host,size,updir,proxy;
   switch (Notebook1->PageIndex)
   {
      case 0:
         if (FtpSite->Text.LowerCase()=="local file")
         {
            NextBtn->Enabled = false;
            NextBtn->Caption = "Run Setup";
            BackBtn->Enabled = true;
            Notebook1->PageIndex = 3;
            FileListBox1Click(NULL);
         }
         else
         {
            if (ProxyHost().Length() && ProxyChecked()) SetFieldsProxy();
            else SetFieldsNoProxy();

            if (GetQSUpdateList(this,FTPfields,ListBox1->Items))
            {
               Application->ProcessMessages(); Sleep(300);
               CancelBtn->Enabled = Notebook1->PageIndex<2;
               NextBtn->Enabled = false;
               BackBtn->Enabled = true;
               Notebook1->PageIndex++;
               MyBeep(MB_OK);
            }
            else Notebook1->PageIndex--;
         }
         break;
      case 1:
         updateinfo = ListBox1->Items->Strings[ListBox1->ItemIndex];
         if (updateinfo.LowerCase().Pos("qsnym.")==1 &&
             ExtractFileExt(updateinfo.LowerCase())==".zip" &&
            !HasPgp())
         {
             if (MsgBoxHwnd(Handle,
                s("I see you are getting the QuickSilver QSnym plugin. I also noticed\n")+
                s("you do not have the QSpgp plugin installed. I can get the nym plugin\n")+
                s("now and install it--that's not a problem--but you will not find it available\n")+
                s("for use until you install the QSpgp plugin.\n\n")+
                s("Also, you'll need some version of PGP. With QSpgp and QSnym installed,\n")+
                s("take a look at the help topic 'Nym Wizard, Your Nym's PGP Key'. You'll\n")+
                s("find an ftp site noted where you can get PGP.\n\n")+
                s("      Get the QSnym plugin now?"),
                s("Information"),MB_OKCANCEL)==IDCANCEL)
                   break;
         }
         name = GetParam(0,updateinfo,",").Trim();
         size = GetParam(1,updateinfo,",").Trim();
         ext = ExtractFileExt(name);
         updir = AppDir+"updates\\";
         if (!DirectoryExists(updir.c_str())) ForceDirectories(updir.c_str());
         if (!DirectoryExists(updir.c_str()))
         {
            MsgBoxHwnd(Handle,
               "Unable to create destination directory!\n("+updir+")",
               "Create Directory",
                MB_OK
            );
            break;
         }
         LocalName = updir+name; // local filename
         FTPfields->Values["LocalFileName"] = LocalName;
         FTPfields->Values["HostFileName"] = name;
         FTPfields->Values["FileSize"] = size; //updateinfo.SubString(name.Length()+1,32).Trim());
         if (FileExists(LocalName)) zapfile(LocalName,1);
         if (GetQSUpdate(this,FTPfields))
         {
            if (ExtractFileExt(LocalName).LowerCase()==".txt")
            {
               Exec95Txt(LocalName);
               break;
            }
            Label6->Caption = LocalName.LowerCase();
            if (IsMixmasterUpdate(LocalName))
               Label3->Caption =
                  "Just run the Mixmaster Setup program, and you're finished!";
            Application->ProcessMessages(); Sleep(300);
            NextBtn->Enabled = true;
            NextBtn->Caption = "Run Setup";
            BackBtn->Enabled = false;
            Notebook1->PageIndex++;
            MyBeep(MB_OK);
         }
         break;
      case 2:
         // this is for ftp updates
         Application->MainForm->Hide();
         Sleep(400); this->Hide(); Sleep(400);
         ext = ExtractFileExt(LocalName.LowerCase());
         if (IsMixmasterUpdate(LocalName)) IsMixmaster = true; else
         if (ext==".zip") Exec95Zip(LocalName);
         ModalResult = mrOk;
         break;
      case 3:
         // this is for local file updates
         Application->MainForm->Hide();
         Sleep(400); this->Hide(); Sleep(400);
         LocalName = FileListBox1->FileName.LowerCase();
         ext = ExtractFileExt(LocalName);
         if (IsMixmasterUpdate(LocalName)) IsMixmaster = true; else
         if (ext==".zip") Exec95Zip(LocalName.LowerCase());
         ModalResult = mrOk;
         break;
      case 4:
         if (HostName->Text.IsEmpty()) SetFieldsNoProxy();
         else SetFieldsProxy();

         if (GetQSUpdateList(this,FTPfields,ListBox1->Items))
         {
            Application->ProcessMessages(); Sleep(300);
            CancelBtn->Enabled = true;
            NextBtn->Enabled = false;
            BackBtn->Enabled = true;
            Notebook1->PageIndex = 1;
            MyBeep(MB_OK);
         }
         break;
   }
}
//---------------------------------------------------------------------------
void __fastcall TUPDateQsDlg::BackBtnClick(TObject *Sender)
{
   switch (Notebook1->PageIndex)
   {
      case 4:
         SetFieldsProxy();
      case 3:
         Notebook1->PageIndex = 0;
         break;
      default:
         Notebook1->PageIndex--;
   }
   switch (Notebook1->PageIndex)
   {
      case 0:
         NextBtn->Enabled = true;
         NextBtn->Caption = "Next";
         BackBtn->Enabled = false;
         break;
      case 1:
         NextBtn->Caption = "Next";
         NextBtn->Enabled = ListBox1->ItemIndex>=0;
         BackBtn->Enabled = true;
         break;
   }
   CancelBtn->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TUPDateQsDlg::EditBtnClick(TObject *Sender)
{
   UPDeditDlg = new TUPDeditDlg(this);
   CenterDialog(UPDeditDlg,this); UPDeditDlg->Top -= 8;
   UPDeditDlg->Memo1->Lines->Text = FtpSite->Items->Text;
   UPDeditDlg->ShowModal();
   if (UPDeditDlg->ModalResult==mrOk)
   {
      FtpSite->Items->Text = UPDeditDlg->Memo1->Lines->Text;
      if (FtpSite->Items->Count) FtpSite->ItemIndex = 0;
      PutAppData(UpdateSites,FtpSite->Items);
   }
   delete UPDeditDlg;
}
//---------------------------------------------------------------------------
void __fastcall TUPDateQsDlg::ListBox1Click(TObject *Sender)
{
   NextBtn->Enabled = ListBox1->ItemIndex>=0;
}
//---------------------------------------------------------------------------
void __fastcall TUPDateQsDlg::FileListBox1Click(TObject *Sender)
{
   NextBtn->Enabled = FileListBox1->ItemIndex>=0;
}
//---------------------------------------------------------------------------
bool __fastcall TUPDateQsDlg::ProxyChecked()
{
   return ClassProxy->Checked || TransProxy->Checked || UserProxy->Checked;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TUPDateQsDlg::ProxyHost()
{
   TStringList *proxy = new TStringList();
   GetAppData(proxy,HttpInfo);
   AnsiString host = proxy->Values["ProxyHost"];
   delete proxy;
   return host;
}
//---------------------------------------------------------------------------
void __fastcall TUPDateQsDlg::NoProxyClick(TObject *Sender)
{
   HostName->Text = "";
   HostDir->Text  = "";
   HostPort->Text = "";
   UserName->Text = "";
   Password->Text = "";
   PassiveBox->Checked = false; PassiveBox->Enabled = false;
   HostName->ReadOnly=true; HostPort->ReadOnly=true;
   UserName->ReadOnly=true; Password->ReadOnly=true;
   HostName->ParentColor=true; HostPort->ParentColor=true;
   UserName->ParentColor=true; Password->ParentColor=true;
   NoProxy->Checked = true;
}
//---------------------------------------------------------------------------
void __fastcall TUPDateQsDlg::TransProxyClick(TObject *Sender)
{
   AnsiString host = GetParam(0,FtpSite->Text,"/");
   HostName->Text = host;
   HostDir->Text  = FtpSite->Text.SubString(host.Length()+1,256);
   HostPort->Text = "21";
   UserName->Text = "anonymous";
   Password->Text = "nobody@nowhere.net";
   PassiveBox->Checked = false; PassiveBox->Enabled = false;
   HostName->ReadOnly=true; HostPort->ReadOnly=true;
   UserName->ReadOnly=true; Password->ReadOnly=true;
   HostName->ParentColor=true; HostPort->ParentColor=true;
   UserName->ParentColor=true; Password->ParentColor=true;
   TransProxy->Checked = true;
}
//---------------------------------------------------------------------------
void __fastcall TUPDateQsDlg::ClassProxyClick(TObject *Sender)
{
   AnsiString host = GetParam(0,FtpSite->Text,"/");
   HostName->Text = ProxyHost();
   HostDir->Text  = FtpSite->Text.SubString(host.Length()+1,256);
   HostPort->Text = "21";
   UserName->Text = "anonymous@"+GetParam(0,FtpSite->Text,"/");
   Password->Text = "nobody@nowhere.net";
   PassiveBox->Checked = true; PassiveBox->Enabled = false;
   HostName->ReadOnly=true; HostPort->ReadOnly=true;
   UserName->ReadOnly=true; Password->ReadOnly=true;
   HostName->ParentColor=true; HostPort->ParentColor=true;
   UserName->ParentColor=true; Password->ParentColor=true;
   ClassProxy->Checked = true;
}
//---------------------------------------------------------------------------
void __fastcall TUPDateQsDlg::UserProxyClick(TObject *Sender)
{
   LoadUserProxy(FTPfields);
//   ActiveControl = HostName;
   HostName->ReadOnly=false; HostPort->ReadOnly=false;
   UserName->ReadOnly=false; Password->ReadOnly=false;
   HostName->Color=clWindow; HostPort->Color=clWindow;
   UserName->Color=clWindow; Password->Color=clWindow;
   UserProxy->Checked = true;
}
//---------------------------------------------------------------------------
void __fastcall TUPDateQsDlg::ProxyBtnClick(TObject *Sender)
{
   if (!ProxyChecked()) NoProxyClick(0);
   NextBtn->Caption = "Next";
   NextBtn->Enabled = true;
   BackBtn->Enabled = true;
   ActiveControl = NextBtn;
   Notebook1->PageIndex = 4;
}
//---------------------------------------------------------------------------
void __fastcall TUPDateQsDlg::UserProxyExit(TObject *Sender)
{
   FTPfields->Clear();
   FTPfields->Add("HostName="+HostName->Text);
   FTPfields->Add("HostDir="+HostDir->Text);
   FTPfields->Add("HostPort="+HostPort->Text);
   FTPfields->Add("UserName="+UserName->Text);
   FTPfields->Add("Password="+Password->Text);
   FTPfields->Add("Passive="+AnsiString(PassiveBox->Checked?1:0));
   if (UserProxy->Checked) StoreUserProxy(FTPfields);
}
//---------------------------------------------------------------------------
void __fastcall TUPDateQsDlg::FtpSiteChange(TObject *Sender)
{
   ProxyBtn->Enabled = FtpSite->Text.LowerCase() != "local file";
   //NProxyBtn->Enabled = YProxyBtn->Enabled;
}
//---------------------------------------------------------------------------
void __fastcall TUPDateQsDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrCancel && Notebook1->PageIndex>0)
   {
      if (MsgBoxHwnd(Handle,"Cancel QuickSilver update?","Confirm",MB_YESNO)==IDNO)
      {
         CanClose = false;
         return;
      }
   }
   SetCurrentDir(AppDir);
}
//---------------------------------------------------------------------------
void __fastcall TUPDateQsDlg::PopupMenuPopup(TObject *Sender)
{
   PopupDeleteItem->Enabled = FileListBox1->ItemIndex >= 0;
}
//---------------------------------------------------------------------------
void __fastcall TUPDateQsDlg::PopupDeleteItemClick(TObject *Sender)
{
   AnsiString thedir = FileListBox1->Directory+"\\";
   AnsiString thefile = FileListBox1->Items->Strings[FileListBox1->ItemIndex];
   if (MsgBoxHwnd(Handle,
      "Delete "+thefile+"\n\nAre you sure?","Delete Update",
       MB_OKCANCEL)==IDOK)
   {
      zapfile(thedir+thefile,1);
      FileListBox1->Update();
   }
}
//---------------------------------------------------------------------------
void __fastcall TUPDateQsDlg::ListBox1DrawItem(TWinControl *Control, int Index,
  TRect &Rect, TOwnerDrawState State)
{
   TRect r(Rect);
   AnsiString text=ListBox1->Items->Strings[Index];
   ListBox1->Canvas->TextRect(r,r.Left+4,r.Top,GetParam(0,text,","));
   r.Left += 139;
   ListBox1->Canvas->TextRect(r,r.Left+4,r.Top,GetParam(1,text,","));
   r.Left += 114;
   ListBox1->Canvas->TextRect(r,r.Left+4,r.Top,GetParam(2,text,","));
}
//---------------------------------------------------------------------------
void __fastcall TUPDateQsDlg::ListBox1DblClick(TObject *Sender)
{
   NextBtn->Click();	
}
//---------------------------------------------------------------------------
